package com.qq.qcloud.tencent_im_sdk_plugin.manager;

import com.qq.qcloud.tencent_im_sdk_plugin.util.CommonUtil;
import com.tencent.imsdk.v2.V2TIMCallback;
import com.tencent.imsdk.v2.V2TIMCreateGroupMemberInfo;
import com.tencent.imsdk.v2.V2TIMGroupApplication;
import com.tencent.imsdk.v2.V2TIMGroupApplicationResult;
import com.tencent.imsdk.v2.V2TIMGroupInfo;
import com.tencent.imsdk.v2.V2TIMGroupInfoResult;
import com.tencent.imsdk.v2.V2TIMGroupMemberFullInfo;
import com.tencent.imsdk.v2.V2TIMGroupMemberInfoResult;
import com.tencent.imsdk.v2.V2TIMGroupMemberOperationResult;
import com.tencent.imsdk.v2.V2TIMManager;
import com.tencent.imsdk.v2.V2TIMValueCallback;


import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;

public class GroupManager {
    private static MethodChannel channel;
    public GroupManager(MethodChannel _channel){
        GroupManager.channel = _channel;
    }


    public void createGroup(MethodCall methodCall, MethodChannel.Result result){
        List<V2TIMCreateGroupMemberInfo> memberList = new LinkedList<V2TIMCreateGroupMemberInfo>();
        memberList.add(new V2TIMCreateGroupMemberInfo());
        V2TIMManager.getGroupManager().createGroup(new V2TIMGroupInfo(), memberList, new V2TIMValueCallback<String>() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess(String s) {

            }
        });
    }
    public void getJoinedGroupList(MethodCall methodCall, MethodChannel.Result result){
        V2TIMManager.getGroupManager().getJoinedGroupList(new V2TIMValueCallback<List<V2TIMGroupInfo>>() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess(List<V2TIMGroupInfo> v2TIMGroupInfos) {

            }
        });
    }
    public void getGroupsInfo(MethodCall methodCall, MethodChannel.Result result){
        List< String > groupIDList = CommonUtil.getParam(methodCall,result,"groupIDList");
        V2TIMManager.getGroupManager().getGroupsInfo(groupIDList, new V2TIMValueCallback<List<V2TIMGroupInfoResult>>() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess(List<V2TIMGroupInfoResult> v2TIMGroupInfoResults) {

            }
        });
    }
    public void setGroupInfo(MethodCall methodCall, MethodChannel.Result result){
        V2TIMManager.getGroupManager().setGroupInfo(new V2TIMGroupInfo(), new V2TIMCallback() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess() {

            }
        });
    }
    public void setReceiveMessageOpt(MethodCall methodCall, MethodChannel.Result result){
        String groupID = CommonUtil.getParam(methodCall,result,"groupID");
        int opt = CommonUtil.getParam(methodCall,result,"opt");
        V2TIMManager.getGroupManager().setReceiveMessageOpt(groupID, opt, new V2TIMCallback() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess() {

            }
        });
    }
    public void initGroupAttributes(MethodCall methodCall, MethodChannel.Result result){
        String groupID  = CommonUtil.getParam(methodCall,result,"groupID");
        HashMap< String, String > attributes = CommonUtil.getParam(methodCall,result,"attributes");
        V2TIMManager.getGroupManager().initGroupAttributes(groupID, attributes, new V2TIMCallback() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess() {

            }
        });
    }
    public void setGroupAttributes(MethodCall methodCall, MethodChannel.Result result){
        String groupID  = CommonUtil.getParam(methodCall,result,"groupID");
        HashMap< String, String > attributes = CommonUtil.getParam(methodCall,result,"attributes");
        V2TIMManager.getGroupManager().setGroupAttributes(groupID, attributes, new V2TIMCallback() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess() {

            }
        });
    }
    public void deleteGroupAttributes(MethodCall methodCall, MethodChannel.Result result){
        String groupID  = CommonUtil.getParam(methodCall,result,"groupID");
        List< String > keys = CommonUtil.getParam(methodCall,result,"keys");
        V2TIMManager.getGroupManager().deleteGroupAttributes(groupID, keys, new V2TIMCallback() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess() {

            }
        });
    }
    public void getGroupAttributes(MethodCall methodCall, MethodChannel.Result result){
        String groupID = CommonUtil.getParam(methodCall,result,"groupID");
        List< String > keys = CommonUtil.getParam(methodCall,result,"keys");
        V2TIMManager.getGroupManager().getGroupAttributes(groupID, keys, new V2TIMValueCallback<Map<String, String>>() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess(Map<String, String> stringStringMap) {

            }
        });
    }
    public void getGroupMemberList(MethodCall methodCall, MethodChannel.Result result){
        String groupID = CommonUtil.getParam(methodCall,result,"groupID");
        int filter = CommonUtil.getParam(methodCall,result,"filter");
        double nextSeq = CommonUtil.getParam(methodCall,result,"nextSeq");
        V2TIMManager.getGroupManager().getGroupMemberList(groupID, filter, new Double(nextSeq).longValue(), new V2TIMValueCallback<V2TIMGroupMemberInfoResult>() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess(V2TIMGroupMemberInfoResult v2TIMGroupMemberInfoResult) {

            }
        });
    }
    public void getGroupMembersInfo(MethodCall methodCall, MethodChannel.Result result){
        String groupID = CommonUtil.getParam(methodCall,result,"groupID");
        List< String > memberList = CommonUtil.getParam(methodCall,result,"memberList");
        V2TIMManager.getGroupManager().getGroupMembersInfo(groupID, memberList, new V2TIMValueCallback<List<V2TIMGroupMemberFullInfo>>() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess(List<V2TIMGroupMemberFullInfo> v2TIMGroupMemberFullInfos) {

            }
        });
    }
    public void setGroupMemberInfo(MethodCall methodCall, MethodChannel.Result result){
        String groupID = CommonUtil.getParam(methodCall,result,"groupID");
        V2TIMManager.getGroupManager().setGroupMemberInfo(groupID, new V2TIMGroupMemberFullInfo(), new V2TIMCallback() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess() {

            }
        });
    }
    public void muteGroupMember(MethodCall methodCall, MethodChannel.Result result){
        String groupID = CommonUtil.getParam(methodCall,result,"groupID");
        String userID = CommonUtil.getParam(methodCall,result,"userID");
        int seconds = CommonUtil.getParam(methodCall,result,"seconds");
        V2TIMManager.getGroupManager().muteGroupMember(groupID, userID, seconds, new V2TIMCallback() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess() {

            }
        });
    }
    public void inviteUserToGroup(MethodCall methodCall, MethodChannel.Result result){
        String groupID = CommonUtil.getParam(methodCall,result,"groupID");
        List< String > userList = CommonUtil.getParam(methodCall,result,"userList");
        V2TIMManager.getGroupManager().inviteUserToGroup(groupID, userList, new V2TIMValueCallback<List<V2TIMGroupMemberOperationResult>>() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess(List<V2TIMGroupMemberOperationResult> v2TIMGroupMemberOperationResults) {

            }
        });
    }
    public void kickGroupMember(MethodCall methodCall, MethodChannel.Result result){
        String groupID = CommonUtil.getParam(methodCall,result,"groupID");
        List< String > memberList = CommonUtil.getParam(methodCall,result,"memberList");
        String reason = CommonUtil.getParam(methodCall,result,"reason");
        V2TIMManager.getGroupManager().kickGroupMember(groupID, memberList, reason, new V2TIMValueCallback<List<V2TIMGroupMemberOperationResult>>() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess(List<V2TIMGroupMemberOperationResult> v2TIMGroupMemberOperationResults) {

            }
        });
    }
    public void setGroupMemberRole(MethodCall methodCall, MethodChannel.Result result){
        String groupID = CommonUtil.getParam(methodCall,result,"groupID");
        String userID = CommonUtil.getParam(methodCall,result,"userID");
        int role = CommonUtil.getParam(methodCall,result,"role");
        V2TIMManager.getGroupManager().setGroupMemberRole(groupID, userID, role, new V2TIMCallback() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess() {

            }
        });
    }
    public void transferGroupOwner(MethodCall methodCall, MethodChannel.Result result){
        String groupID = CommonUtil.getParam(methodCall,result,"groupID");
        String userID = CommonUtil.getParam(methodCall,result,"userID");
        V2TIMManager.getGroupManager().transferGroupOwner(groupID, userID, new V2TIMCallback() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess() {

            }
        });
    }
    public void getGroupApplicationList(MethodCall methodCall, MethodChannel.Result result){
        V2TIMManager.getGroupManager().getGroupApplicationList(new V2TIMValueCallback<V2TIMGroupApplicationResult>() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess(V2TIMGroupApplicationResult v2TIMGroupApplicationResult) {

            }
        });
    }
    public void acceptGroupApplication(MethodCall methodCall, MethodChannel.Result result){
        String reason = CommonUtil.getParam(methodCall,result,"reason");
        V2TIMManager.getGroupManager().acceptGroupApplication(new V2TIMGroupApplication(), reason, new V2TIMCallback() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess() {

            }
        });
    }
    public void refuseGroupApplication(MethodCall methodCall, MethodChannel.Result result){
        String reason = CommonUtil.getParam(methodCall,result,"reason");
        V2TIMManager.getGroupManager().refuseGroupApplication(new V2TIMGroupApplication(), reason, new V2TIMCallback() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess() {

            }
        });
    }
    public void setGroupApplicationRead(MethodCall methodCall, MethodChannel.Result result){
        V2TIMManager.getGroupManager().setGroupApplicationRead(new V2TIMCallback() {
            @Override
            public void onError(int i, String s) {

            }

            @Override
            public void onSuccess() {

            }
        });
    }

}
