import 'package:tencent_im_sdk_plugin/class/V2TIMGroupChangeInfo.dart';
import 'package:tencent_im_sdk_plugin/class/V2TIMGroupMemberChangeInfo.dart';
import 'package:tencent_im_sdk_plugin/class/V2TIMGroupMemberInfo.dart';

abstract class V2TIMGroupListener {
  void onMemberEnter(String groupID, List<V2TIMGroupMemberInfo> memberList) {}

  void onMemberLeave(String groupID, V2TIMGroupMemberInfo member) {}

  void onMemberInvited(String groupID, V2TIMGroupMemberInfo opUser,
      List<V2TIMGroupMemberInfo> memberList) {}

  void onMemberKicked(String groupID, V2TIMGroupMemberInfo opUser,
      List<V2TIMGroupMemberInfo> memberList) {}

  void onMemberInfoChanged(String groupID,
      List<V2TIMGroupMemberChangeInfo> v2TIMGroupMemberChangeInfoList) {}

  void onGroupCreated(String groupID) {}

  void onGroupDismissed(String groupID, V2TIMGroupMemberInfo opUser) {}

  void onGroupRecycled(String groupID, V2TIMGroupMemberInfo opUser) {}

  void onGroupInfoChanged(
      String groupID, List<V2TIMGroupChangeInfo> changeInfos) {}

  void onReceiveJoinApplication(
      String groupID, V2TIMGroupMemberInfo member, String opReason) {}

  void onApplicationProcessed(String groupID, V2TIMGroupMemberInfo opUser,
      bool isAgreeJoin, String opReason) {}

  void onGrantAdministrator(String groupID, V2TIMGroupMemberInfo opUser,
      List<V2TIMGroupMemberInfo> memberList) {}

  void onRevokeAdministrator(String groupID, V2TIMGroupMemberInfo opUser,
      List<V2TIMGroupMemberInfo> memberList) {}

  void onQuitFromGroup(String groupID) {}

  void onReceiveRESTCustomData(String groupID, List<String> customData) {}

  void onGroupAttributeChanged(
      String groupID, Map<String, String> groupAttributeMap) {}
}
