import 'package:flutter/services.dart';

class V2TIMConversationManager {
  MethodChannel _channel = null;
  Set conversationListener = new Set();
  V2TIMConversationManager(channel) {
    this._channel = channel;
  }
  void setConversationListener(Function listener) {
    conversationListener.add(listener);
    _channel.invokeMethod("setConversationListener", buildParam({}));
  }

  Future<Map> getConversationList(
    double nextSeq,
    int count,
  ) async {
    return await _channel.invokeMethod(
        "getConversationList",
        buildParam({
          "nextSeq": nextSeq,
          "count": count,
        }));
  }

  Future<Map> deleteConversation(
    String conversationID,
  ) async {
    return await _channel.invokeMethod(
        "deleteConversation",
        buildParam({
          "conversationID": conversationID,
        }));
  }

  Future<Map> setConversationDraft(String conversationID,
      [String draftText]) async {
    return await _channel.invokeMethod(
        "setConversationDraft",
        buildParam({
          "conversationID": conversationID,
          "draftText": draftText == null ? "" : draftText,
        }));
  }

  Map buildParam(Map param) {
    param["TIMManagerName"] = "conversationManager";
    return param;
  }
}
