import 'package:flutter/services.dart';

class V2TIMOfflinePushManager {
  MethodChannel _channel = null;
  V2TIMOfflinePushManager(channel) {
    _channel = channel;
  }
  Future<void> setOfflinePushConfig(String businessID, String token) async {
    await _channel.invokeMethod("setOfflinePushConfig",
        buildParam({"businessID": businessID, "token": token}));
  }

  Future<void> doBackground(int unreadCount) async {
    await _channel.invokeMethod(
        "doBackground",
        buildParam({
          "unreadCount": unreadCount,
        }));
  }

  Future<void> doForeground() async {
    await _channel.invokeMethod("doForeground", buildParam({}));
  }

  Map buildParam(Map param) {
    param["TIMManagerName"] = "offlinePushManager";
    return param;
  }
}
